      subroutine mkc(nse,h,A,B,K2,K0)
       implicit real*8 (a-h,o-z)
       real*8 A(2*nse,*),B(2*nse,*),K2(2,*),K0(2,*)
       
        s1=(9.0d0+4.0d0*dsqrt(3.0d0))/18.0d0
        s2=(3.0d0+dsqrt(3.0d0))/36.0d0
        s3=(3.0d0-dsqrt(3.0d0))/36.0d0
        s5=2.0d0*dsqrt(3.0d0)
        s6=dsqrt(3)+1.0d0
        s7=dsqrt(3)-1.0d0
        a1=s1
        a2=s2
        a3=1.0d0-s1
        a4=s3

        h2=1.0d0/h**2.0d0 
        K2(1,1)=-s5*h2
        K2(1,2)=-s6/h
        K2(1,3)=s5*h2
        K2(1,4)=-s7/h
        K2(2,1)=s5*h2
        K2(2,2)=s7/h
        K2(2,3)=-s5*h2
        K2(2,4)=s6/h


        K0(1,1)=a1
        K0(1,2)=a2*h
        K0(1,3)=a3
        K0(1,4)=-h*a4
        K0(2,1)=a3
        K0(2,2)=h*a4
        K0(2,3)=a1
        K0(2,4)=-h*a2

        A(1,1)=K2(1,1)  
        A(1,2)=K2(1,3)  
        A(1,3)=K2(1,4) 
        A(2,1)=K2(2,1)  
        A(2,2)=K2(2,3)  
        A(2,3)=K2(2,4) 
        B(1,1)=K0(1,1)  
        B(1,2)=K0(1,3)  
        B(1,3)=K0(1,4) 
        B(2,1)=K0(2,1)  
        B(2,2)=K0(2,3)  
        B(2,3)=K0(2,4) 
        ns=2*nse

        do i=3,ns-3,2
          A(i,i-1)=K2(1,1)  
          A(i,i)=K2(1,2) 
          A(i,i+1)=K2(1,3)  
          A(i,i+2)=K2(1,4) 
          A(i+1,i-1)=K2(2,1)  
          A(i+1,i)=K2(2,2) 
          A(i+1,i+1)=K2(2,3) 
          A(i+1,i+2)=K2(2,4) 
          B(i,i-1)=K0(1,1)
          B(i,i)=K0(1,2) 
          B(i,i+1)=K0(1,3) 
          B(i,i+2)=K0(1,4) 
          B(i+1,i-1)=K0(2,1) 
          B(i+1,i)=K0(2,2) 
          B(i+1,i+1)=K0(2,3)  
          B(i+1,i+2)=K0(2,4) 
        enddo

        A(ns-1,ns-2)=K2(1,1)  
        A(ns-1,ns-1)=K2(1,2) 
        A(ns-1,ns)=K2(1,3) 
        A(ns,ns-2)=K2(2,1)  
        A(ns,ns-1)=K2(2,2)  
        A(ns,ns)=K2(2,3) 
        B(ns-1,ns-2)=K0(1,1)  
        B(ns-1,ns-1)=K0(1,2)  
        B(ns-1,ns)=K0(1,3) 
        B(ns,ns-2)=K0(2,1)  
        B(ns,ns-1)=K0(2,2)  
        B(ns,ns)=K0(2,3) 

       return
       end
